include_theme('lightning-rabbit')
include_theme('body-background-image')

@headline_logo_image = "usa1.png"
include_theme("headline-logo")

def Kernel.log(msg)
  open('log', 'w') { |f| f.puts msg.to_s }
end

match(TitleSlide) do |elements|
  elements.prop_set('size', screen_size(8) * Pango::SCALE)
end

match('**', Text) do |elements|
  elements.each do |text|
    case text.text
    when /4gamer/
      text.prop_set('size', screen_size(2.5) * Pango::SCALE)
    when /bugs\.ruby-lang\.org/
      text.prop_set('size', screen_size(4) * Pango::SCALE)
    when /Feature #/, /Show documents when completion/
      text.prop_set('size', screen_size(4) * Pango::SCALE)
    when /How is/
      text.prop_set('size', screen_size(5) * Pango::SCALE)
    when /https?:\/\//
      text.prop_set('size', screen_size(4) * Pango::SCALE)
    end
  end
end

match('**', BlockQuote) do |elements|
  elements.each do |text|
    case text.text
    when /https?:\/\//
      text.prop_set('size', screen_size(4) * Pango::SCALE)
    when /ANSI/
      text.prop_set('size', screen_size(4) * Pango::SCALE)
    else
      text.prop_set('size', screen_size(2.8) * Pango::SCALE)
    end
  end
end

match('*', HeadLine) do |elements|
  elements.each do |headline|
    if headline.text.match?(/GNU/)
      headline.prop_set('size', screen_size(4.5) * Pango::SCALE)
    else
      headline.prop_set('size', screen_size(5.2) * Pango::SCALE)
    end
  end
end

match('**', ItemListItem) do |elements|
  elements.prop_set('size', screen_size(5.0) * Pango::SCALE)
  elements.padding_top = 0
  elements.padding_bottom = 0
  elements.margin_top = 0
  elements.margin_bottom = 0
end

match('**', ItemListItem, '**', ItemListItem) do |elements|
  elements.prop_set('size', screen_size(4.0) * Pango::SCALE)
  elements.padding_top = 0
  elements.padding_bottom = 0
  elements.margin_top = 0
  elements.margin_bottom = 0
end

match('**', ItemListItem, '**', ItemListItem, '**', ItemListItem) do |elements|
  elements.prop_set('size', screen_size(3.3) * Pango::SCALE)
  elements.padding_top = 0
  elements.padding_bottom = 0
  elements.margin_top = 0
  elements.margin_bottom = 0
end

match('**', ItemListItem, '**', ItemListItem, '**', ItemListItem, '**', ItemListItem) do |elements|
  elements.prop_set('size', screen_size(3) * Pango::SCALE)
  elements.padding_top = 0
  elements.padding_bottom = 0
  elements.margin_top = 0
  elements.margin_bottom = 0
  elements.margin_left = screen_size(4)
end

match('**', ItemListItem) do |elements|
  elements.select{ |e| e.text.match?(/codepoint/) }.each do |e|
    e.prop_set('size', screen_size(4) * Pango::SCALE)
  end
end

match('**', Image) do |images|
  images.each do |image|
    if image.caption&.match?(/http/) or image.caption&.match?(/facial expression/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(3) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/Desk Set/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(4.5) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/Kobayashi/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(3) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/fuses/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(4) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/the hell/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(4.5) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/Asakusa.rb/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(4.3) * Pango::SCALE
        end
        [x, y, w, h]
      end
    else
      image.add_pre_draw_proc(:restore_url) do |canvas, x, y, w, h, simulation|
        if @image_caption_font_size_backup
          @image_caption_font_size = @image_caption_font_size_backup
          @image_caption_font_size_backup = nil
        end
        [x, y, w, h]
      end
    end
  end
end

match('*') do |elements|
  elements.each do |slide|
    if slide.title.match?(/fullimage/)
      slide.each do |e|
        if e.instance_of?(Body)
          image = e.first
          image.add_pre_draw_proc(:bbbb) do |canvas, x, y, w, h, simulation|
            image.resize(canvas.width, canvas.height)
            [0.0, 0.0, w, h]
          end
        end
      end
    elsif slide.title.match?(/notitle/)
      slide.each do |e|
        if e.instance_of?(HeadLine)
          e.prop_set('size', screen_size(0) * Pango::SCALE)
        end
      end
    elsif slide.title.match?(/Asakusa\.rb/)
      if (slide.any?{ |e| e.text.match?(/One other/) })
        slide.each do |e|
          e.each do |inside|
            if inside.instance_of?(BlockQuote)
              inside.prop_set('size', screen_size(4) * Pango::SCALE)
            end
          end
        end
      end
    elsif slide.title.match?(/The History of Terminal/)
      if (slide.any?{ |e| e.text.match?(/reset/) })
        slide.each do |e|
          e.each do |inside|
            if inside.instance_of?(PreformattedBlock)
              inside.prop_set('size', screen_size(2.8) * Pango::SCALE)
            end
          end
        end
      end
    end
  end
end
